﻿package{
	
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.display.DisplayObject;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	/*Lire la doc pour ColorTransform*/
	import flash.geom.ColorTransform;
	
	public class Branches extends Sprite{
		
		private var stack:Array = new Array();
		private var stylo:Sprite = new Sprite();
		private var sketch:Sprite = new Sprite();
		private var bg:BitmapData;
		private var container:Bitmap;
		private var boule:Ext_sprite;
		private var inc:Number = 0;
		private var DOWNallaiseX:Number = 0;
		private var DOWNallaiseY:Number = 0;
		private var UPallaiseX:Number = 0;
		private var UPallaiseY:Number = 0;
		private var incre:Number;
		private var red:Number;
		private var green:Number;
		private var blue:Number;
		
		public function Branches(){
			/*Creation du bitmapDATA pour  copier nos vecteurs*/
			bg = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x00000000);
			container = new Bitmap(bg);
			addChild(container);
			addChild(sketch);
			/*Affectation des écouteurs de la souris*/
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
			}
		/*Quand on click sur la souris, on efface le trait de repérage, on libère de la mémoire, on affecte l'écouteur sur le mouvement de la souris*/	
		private function downHandler(event:MouseEvent):void{
			DOWNallaiseX = mouseX;
			DOWNallaiseY = mouseY;
			//trace(DOWNallaiseX);
			stack = new Array();
			stylo.graphics.clear();
			stylo.graphics.lineStyle(1,0xffffff,1);
			stylo.graphics.moveTo(DOWNallaiseX,DOWNallaiseY);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
			}
		
		/*Quand on bouge la souris, on stock les points, on dessine le repère et on l'ajoute au stage pour le voir*/
		private function moveHandler(event:MouseEvent):void{
			
			stack.push({'X':mouseX,'Y':mouseY});
			//stylo.graphics.lineTo(mouseX,mouseY);
			addChild(stylo);
			}
		/*Quand on lache la souris, on dessine des boules tous les 5 points, on leur affect un écouteur ENTER_FRAME et on supprime l'écouteur MOUSE_MOVE*/
		 private function upHandler(event:MouseEvent):void {
			for(var i:Number=0;i<stack.length;i++){
				UPallaiseX = mouseX;
				UPallaiseY = mouseY;
				stylo.graphics.lineTo(UPallaiseX,UPallaiseY);
				//trace(UPallaiseX)
			
			//trace(UPallaiseX);
				if(i==2){
					inc++
					incre=0;
					/*
					red = inc/10
					green = inc/5
					blue = inc/2
					*/
					
					boule = new Ext_sprite();
					//boule.transform.colorTransform = new ColorTransform( /*Rouge*/red ,/*Vert*/green,/*Bleu*/blue,/*Alpha*/1, 0, 1, 0, 0);
					boule.name = "boule"+inc;
					boule.graphics.beginFill(0x555555,.6);
					boule.graphics.lineStyle(1,0xffffff,.0);
					boule.graphics.drawCircle(stack[i].X,stack[i].Y,20);//Math.random()*60);
					boule.graphics.endFill();
					boule.vx = ((DOWNallaiseX-UPallaiseX)/6);//-DOWNallaiseX);
					boule.vy = ((DOWNallaiseY-UPallaiseY)/6);//-DOWNallaiseY);
					//boule.stageX=DOWNallaiseX;
					//boule.stageY=DOWNallaiseY;
					boule.addEventListener(Event.ENTER_FRAME,enterHandler);
					sketch.addChild(boule);
					
					
					
					}
				
				}
				
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,moveHandler);
			
			}
		/*Function pour faire bouger les boules et les dessiner ds notre BitmapDATA*/
		private function enterHandler(e:Event):void{
				e.currentTarget.vx += (Math.cos ( e.currentTarget.vx*Math.PI/180)*(e.currentTarget.vx/12 ))/10;
				e.currentTarget.vy += Math.sin ( e.currentTarget.vy*Math.PI/180)*(e.currentTarget.vy/12 )+.0;
				if((e.currentTarget.stageY - e.currentTarget.height*2) > stage.stageHeight || (e.currentTarget.stageX - e.currentTarget.width/2) > stage.stageWidth || (e.currentTarget.stageY + e.currentTarget.height/2) < 0 || (e.currentTarget.stageX + e.currentTarget.width/2) < 0){
					e.currentTarget.removeEventListener(Event.ENTER_FRAME,enterHandler);
					sketch.removeChildAt(sketch.getChildIndex(sketch.getChildByName(e.currentTarget.name)));
					
				}else{
					if (incre <= 250){
					incre+=1
					}else{
					
					}
					red = incre/20
					green = incre/100
					blue = incre/30
					
					e.currentTarget.stageX+=e.currentTarget.vx;
					e.currentTarget.stageY+=e.currentTarget.vy;
					e.currentTarget.x+=e.currentTarget.vx;
					e.currentTarget.y+=e.currentTarget.vy;
					e.currentTarget.width-=.5;
					e.currentTarget.height-=.5;
					e.currentTarget.transform.colorTransform = new ColorTransform( /*Rouge*/red,/*Vert*/green,/*Bleu*/blue,/*Alpha*/1, 0, 1, 0, 0);
					bg.draw(sketch);
					//trace(sketch.removeChildAt(4));
					trace(incre)
				}
			}
		
		}
	}
/*Nouvelle classe pour Sprite dans le but de pouvoir passer des paramètres*/	
import flash.display.Sprite;
class Ext_sprite extends Sprite{
	public var vx:Number;
	public var vy:Number;
	public var stageX:Number;
	public var stageY:Number;
	public function Ext_sprite(){
		}
	}